> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/ai-in-umbraco/17.latest/management-api/contexts/update.md).

# Update Context

Updates an existing context. A new version is created automatically.

## Request

```http
PUT /umbraco/ai/management/api/v1/contexts/{contextIdOrAlias}
```

### Path Parameters

| Parameter          | Type   | Description           |
| ------------------ | ------ | --------------------- |
| `contextIdOrAlias` | string | Context GUID or alias |

### Request Body

{% code title="Request" %}

```json
{
    "alias": "brand-voice",
    "name": "Brand Voice Updated",
    "resources": [
        {
            "id": "d290f1ee-6c54-4b01-90e6-d701748f0851",
            "resourceTypeId": "text",
            "name": "Tone of Voice",
            "description": "Updated writing style guidelines",
            "sortOrder": 0,
            "settings": "Always use a friendly, professional, and engaging tone...",
            "injectionMode": "Always"
        },
        {
            "resourceTypeId": "text",
            "name": "Key Messages",
            "sortOrder": 1,
            "settings": "Our core values are...",
            "injectionMode": "Always"
        }
    ]
}
```

{% endcode %}

{% hint style="info" %}
Include existing resource IDs to update them. Resources without IDs are created as new. Omitting an existing resource removes it.
{% endhint %}

## Response

### Success

{% code title="200 OK" %}

```
(empty response body)
```

{% endcode %}

### Not Found

{% code title="404 Not Found" %}

```json
{
    "type": "https://tools.ietf.org/html/rfc7231#section-6.5.4",
    "title": "Not Found",
    "status": 404,
    "detail": "Context not found"
}
```

{% endcode %}

### Validation Error

{% code title="400 Bad Request" %}

```json
{
    "type": "https://tools.ietf.org/html/rfc7231#section-6.5.1",
    "title": "Duplicate alias",
    "status": 400,
    "detail": "A context with this alias already exists."
}
```

{% endcode %}

## Examples

{% code title="cURL" %}

```bash
curl -X PUT "https://your-site.com/umbraco/ai/management/api/v1/contexts/3fa85f64-5717-4562-b3fc-2c963f66afa6" \
  -H "Authorization: Bearer YOUR_ACCESS_TOKEN" \
  -H "Content-Type: application/json" \
  -d '{
    "alias": "brand-voice",
    "name": "Brand Voice Updated",
    "resources": [
      {
        "id": "d290f1ee-6c54-4b01-90e6-d701748f0851",
        "resourceTypeId": "text",
        "name": "Tone of Voice",
        "settings": "Updated content..."
      }
    ]
  }'
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.umbraco.com/ai-in-umbraco/17.latest/management-api/contexts/update.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
